#!/usr/bin/env python
import os, sys

Huge = 1.0e+10
out_fold = './figures'
problems = ['lrb','svm','sh']

lrb_log_fold = './logLRb'
svm_log_fold = './logSVM'
sh_log_fold = './logLRb'
log_fold = {'lrb':lrb_log_fold,\
			'svm':svm_log_fold,\
			'sh':sh_log_fold}

lrb_solver_list = ['CDN','newGLMNET','GLMNET','GLMNETpath']
svm_solver_list = ['CDN','newGLMNET']
sh_solver_list = ['newGLMNET','newGLMNET-ISH','newGLMNET-OSH','newGLMNET-NSH']
solver_list = {'lrb':lrb_solver_list,\
			   'svm':svm_solver_list,\
			   'sh':sh_solver_list}

fopt_refer_list = {'lrb':'OPT','svm':'OPT','sh':'OPT'}

# The best parameter C is selected by 5-fold cross-validation
bestC = {}
bestC[('news20','lrb')] = 64.0
bestC[('rcv1','lrb')] = 4.0
#bestC[('yahoojp','lrb')] = 4.0
#bestC[('yahookr','lrb')] = 4.0
#bestC[('gis','lrb')] = 0.25
#bestC[('eps','lrb')] = 0.5
#bestC[('webspam','lrb')] = 64.0
#bestC[('kddb','lrb')] = 0.5

bestC[('news20','svm')] = 64.0
bestC[('rcv1','svm')] = 1.0
#bestC[('yahoojp','svm')] = 1.0
#bestC[('yahookr','svm')] = 1.0
#bestC[('gis','svm')] = 0.0625
#bestC[('eps','svm')] = 0.125
#bestC[('webspam','svm')] = 32.0
#bestC[('kddb','svm')] = 0.25

#ref
#CDN-LRB
defobj = {}
defobj[('news20','lrb')] = 37065.636890
defobj[('rcv1','lrb')] = 133392.140982
defobj[('yahoojp','lrb')] = 89019.360161
defobj[('yahookr','lrb')] = 414881.811992
defobj[('gis','lrb')] = 99.055478
defobj[('eps','lrb')] = 53008.283009
defobj[('webspam','lrb')] = 131384.906208
defobj[('kddb','lrb')] = 2612953.279387

defacc = {}
defacc[('news20','lrb')] = 0.957239
defacc[('rcv1','lrb')] = 0.978019
defacc[('yahoojp','lrb')] = 0.930789
defacc[('yahookr','lrb')] = 0.876973
defacc[('gis','lrb')] = 0.986000
defacc[('eps','lrb')] = 0.898790
defacc[('webspam','lrb')] = 0.996557
defacc[('kddb','lrb')] = 0.867405

#CDN-SVM
defobj[('news20','svm')] = 12298.411673
defobj[('rcv1','svm')] = 40401.912571
defobj[('yahoojp','svm')] = 29718.244586
defobj[('yahookr','svm')] = 132684.699405
defobj[('gis','svm')] = 27.206393
defobj[('eps','svm')] = 17070.095498
defobj[('webspam','svm')] = 38609.740375
defobj[('kddb','svm')] = 1488807.387265

defacc[('news20','svm')] = 0.958990
defacc[('rcv1','svm')] = 0.978004
defacc[('yahoojp','svm')] = 0.928547
defacc[('yahookr','svm')] = 0.877125
defacc[('gis','svm')] = 0.982000
defacc[('eps','svm')] = 0.898640
defacc[('webspam','svm')] = 0.996286
defacc[('kddb','svm')] = 0.865572


PLOT = {}
PLOT['obj2'] = 1
PLOT['acc'] = 1

'ylabelcode,axistype,xmin,xmax,ymin,ymax'
obj2_code = '0,3,0,0,0,0'
acc_code  = '1,1,0,0,0,0'

obj2_code_table = {}
acc_code_table  = {}

#XXX lrb
obj2_code_table[('news20','lrb')] = '0,3,0.7,200,0.000001,30'
obj2_code_table[('rcv1','lrb')] = '0,3,2,10000,0.00000001,20'
obj2_code_table[('yahoojp','lrb')] = '0,3,1,500,0.000001,2'
obj2_code_table[('yahookr','lrb')] = '0,3,9,5000,0.000001,2'
obj2_code_table[('gis','lrb')] = '0,3,0.3,1000,0.000001,10'
obj2_code_table[('eps','lrb')] = '0,3,15,10000,0.000001,10'
obj2_code_table[('webspam','lrb')] = '0,3,60,100000,0.0001,100'
obj2_code_table[('kddb','lrb')] = '0,3,60,100000,0.000001,2'

acc_code_table[('news20','lrb')] = '1,1,0.7,200,0.91,0.97'
acc_code_table[('rcv1','lrb')] = '1,1,2,10000,0.972,0.979'
acc_code_table[('yahoojp','lrb')] = '1,1,1,500,0.905,0.935'
acc_code_table[('yahookr','lrb')] = '1,1,9,5000,0.84,0.88'
acc_code_table[('gis','lrb')] = '1,1,0.3,1000,0.96,0.99'
acc_code_table[('eps','lrb')] = '1,1,15,10000,0.87,0.905'
acc_code_table[('webspam','lrb')] = '1,1,60,100000,0.993,0.997'
acc_code_table[('kddb','lrb')] = '1,1,60,100000,0.858,0.868'

#XXX svm
obj2_code_table[('news20','svm')] = '0,3,0.3,500,0.000001,100'
obj2_code_table[('rcv1','svm')] = '0,3,1,500,0.00000001,10'
obj2_code_table[('yahoojp','svm')] = '0,3,0.4,100,0.000001,2'
obj2_code_table[('yahookr','svm')] = '0,3,3,1000,0.000001,1'
obj2_code_table[('gis','svm')] = '0,3,0.3,100,0.00000001,10'
obj2_code_table[('eps','svm')] = '0,3,7,3000,0.000001,1'
obj2_code_table[('webspam','svm')] = '0,3,10,10000,0.0001,100'
obj2_code_table[('kddb','svm')] = '0,3,30,10000,0.000001,1'

acc_code_table[('news20','svm')] = '1,1,0.3,500,0.92,0.97'
acc_code_table[('rcv1','svm')] = '1,1,1,500,0.97,0.979'
acc_code_table[('yahoojp','svm')] = '1,1,0.4,100,0.921,0.93'
acc_code_table[('yahookr','svm')] = '1,1,3,1000,0.85,0.88'
acc_code_table[('gis','svm')] = '1,1,0.3,100,0.965,0.988'
acc_code_table[('eps','svm')] = '1,1,7,3000,0.865,0.902'
acc_code_table[('webspam','svm')] = '1,1,10,10000,0.99,0.997'
acc_code_table[('kddb','svm')] = '1,1,30,10000,0.854,0.868'

STYLE = {'CDN':'-r.','newGLMNET':':b+',\
		 'GLMNET':'--go','GLMNETpath':'-.ko',\
		 'newGLMNET-ISH':':ro','newGLMNET-OSH':'-.go','newGLMNET-NSH':'--k.'}
LEGEND = {'CDN':'CDN','newGLMNET':'newGLMNET',\
		  'GLMNET':'GLMNET','GLMNETpath':'GLMNETpath',\
		  'newGLMNET-ISH':'Inner only','newGLMNET-OSH':'Outer only',\
		  'newGLMNET-NSH':'No shrinking'}


def figure(problem='lrb'):
	where = log_fold[problem]
	whos = solver_list[problem]
	frefer = fopt_refer_list[problem]

	legends = ','.join(map(lambda one: "'"+LEGEND[one]+"'", whos))
	linestyles = ','.join(map(lambda one: "'"+STYLE[one]+"'", whos))
	issh = False

	for key in bestC.keys():
		if problem=='sh':
			issh = True
			problem='lrb'
		if key[1] != problem:
			continue
		which = key[0]
		C = bestC[(which,problem)]

		(obj,nr0) = (Huge,0)
		foptlog = '%s/%s_%s_%s.log' %(where,frefer,which,C)
		if os.path.exists(foptlog):
			fp = open(foptlog, 'r')
			for line in fp:
				if line.endswith('\n') and\
				   line.find('time')!=-1 and line.find('f')!=-1 and\
				   line.find('accuracy')!=-1 and line.find('nonzero')!=-1:
					lst = line.strip().split()
					tmpobj = float(lst[lst.index('f')+1])
					tmpnr0 = int(lst[lst.index('nonzero')+1])
					assert tmpobj>0 and tmpnr0>=0
					if tmpobj < obj:
						obj = tmpobj
						nr0 = tmpnr0
			fp.close()
		else:
			print '-----------------------------------'
			print 'WARNING:', foptlog, 'does not exist!'
			print '-----------------------------------'
			(obj,nr0) = (0,0)

		#to draw horizonal line to indicate the performance
		#in default seting
		(obj1level,obj2level,acclevel) = (0.0,0.01,0.0)
		if defobj.has_key((which,problem)):
			obj1level = defobj[(which,problem)]
			obj2level = max(0.0, (obj1level-obj)/obj)
		if defacc.has_key((which,problem)):
			acclevel = defacc[(which,problem)]

		for one in whos:
			onelog = '%s/%s_%s_%s.log' %(where,one,which,C)
			if not os.path.exists(onelog):
				print '-----------------------------------'
				print 'WARNING:', onelog, 'does not exist!'
				print '-----------------------------------'
				obj_out = open('./tmp/%s.obj'%one, 'w')
				acc_out = open('./tmp/%s.acc'%one, 'w')
				nr0_out = open('./tmp/%s.nr0'%one, 'w')
				obj_out.write('0\t0\n')
				acc_out.write('0\t0\n')
				nr0_out.write('0\t0\n')
				obj_out.close()
				acc_out.close()
				nr0_out.close()
				continue

			print onelog
			fp = open(onelog, 'r')
			obj_out = open('./tmp/%s.obj'%one, 'w')
			acc_out = open('./tmp/%s.acc'%one, 'w')
			nr0_out = open('./tmp/%s.nr0'%one, 'w')
			(lasttime,lastobj) = (1.0e-6,Huge)
			linecount = 0
			for line in fp:
				if line.endswith('\n') and\
				   line.find('time')!=-1 and line.find('f')!=-1 and\
				   line.find('accuracy')!=-1 and line.find('nonzero')!=-1:
					lst = line.strip().split()
					###
					#if int(lst[lst.index('iter')+1])==0:
					#	continue
					###
					ff = float(lst[lst.index('f')+1])
					if ff>lastobj or ff<=0: continue
					tt = float(lst[lst.index('time')+1])
					tt = max(tt,lasttime)
					(lasttime,lastobj) = (tt,ff)
					try:
						ff = max(0.0, (ff-obj)/obj)
					except:
						pass
					aa = float(lst[lst.index('accuracy')+1])
					nn = float(lst[lst.index('nonzero')+1])
					assert tt>0 and ff>0 and aa>=0
					obj_line = '%s\t%s\n' %(tt,ff)
					acc_line = '%s\t%s\n' %(tt,aa)
					nr0_line = '%s\t%s\n' %(tt,nn)
					obj_out.write(obj_line)
					acc_out.write(acc_line)
					nr0_out.write(nr0_line)
					linecount += 1
			fp.close()
			obj_out.close()
			acc_out.close()
			nr0_out.close()

			if linecount==0:
				obj_out = open('./tmp/%s.obj'%one, 'w')
				acc_out = open('./tmp/%s.acc'%one, 'w')
				nr0_out = open('./tmp/%s.nr0'%one, 'w')
				obj_out.write('0\t0\n')
				acc_out.write('0\t0\n')
				nr0_out.write('0\t0\n')
				obj_out.close()
				acc_out.close()
				nr0_out.close()

		obj2_code = '0,3,0,0,0,0'
		acc_code  = '1,1,0,0,0,0'

		# obj2
		if issh:
			outfile = '%s/sh_%s_%s_obj2' % (out_fold,problem,which)
		else:
			outfile = '%s/%s_%s_obj2' % (out_fold,problem,which)
		infiles = ','.join(map(lambda one: "'./tmp/"+one+".obj'", whos))
		if obj2_code_table.has_key((which,problem)):
			obj2_code = obj2_code_table[(which,problem)]
		cmd = \
'''matlab -nodisplay -r "addpath('tools'); outfile='%s'; infiles={%s}; legends={%s}; linestyles={%s}; draw(outfile, infiles, linestyles, legends, %s, %s); quit;" >>./tmp/log.log
''' % (outfile,infiles,legends,linestyles,obj2_code,obj2level)
		if PLOT['obj2']:
			print cmd
			os.system(cmd)

		# acc
		if issh:
			outfile = '%s/sh_%s_%s_acc' % (out_fold,problem,which)
		else:
			outfile = '%s/%s_%s_acc' % (out_fold,problem,which)
		infiles = ','.join(map(lambda one: "'./tmp/"+one+".acc'", whos))
		if acc_code_table.has_key((which,problem)):
			acc_code = acc_code_table[(which,problem)]
		cmd = \
'''matlab -nodisplay -r "addpath('tools'); outfile='%s'; infiles={%s}; legends={%s}; linestyles={%s}; draw(outfile, infiles, linestyles, legends, %s, %s); quit;" >>./tmp/log.log
''' % (outfile,infiles,legends,linestyles,acc_code,acclevel)
		if PLOT['acc']:
			print cmd
			os.system(cmd)


if __name__ == '__main__':
	if len(sys.argv) > 1:
		assert sys.argv[1] in problems
		figure(sys.argv[1])
	else:
		figure()

